/*
 * $Id: ColorModC.h,v 1.1 1998/06/24 01:29:07 lang Exp $
 *
 * Copyright (c) 1992 HAL Computer Systems International, Ltd.
 * 
 *          HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                  1315 Dell Avenue
 *                  Campbell, CA  95008
 *
 * Author: Greg Hilton
 * Contributors: Tom Lang, Frank Bieser, and others
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * http://www.gnu.org/copyleft/gpl.html
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _ColorModC_h_
#define _ColorModC_h_

#include "StringC.h"
#include <Xm/Xm.h>

class ColorModC {

   Widget	shell;
   Widget	form;
   Widget	label;
   Widget	da;
   Widget	tf;
   Widget	pb;

//
// Current state
//
   Pixel	value;
   StringC	name;
   Boolean	changed;

//
// Initial state
//
   struct {
      Pixel	value;
      StringC	name;
   } init;

//
// Callbacks
//
   static void	HandleNameChange(Widget, ColorModC*, XtPointer);
   static void  HandleMapChange(Widget, ColorModC*, XEvent*, Boolean*);
   static void	DoShowColorPicker(Widget, ColorModC*, XtPointer);
   static void	DoHideColorPicker(Widget, ColorModC*, XtPointer);
   static void	DoColorPickerAction(Widget, XtPointer, XtPointer);

public:

// Methods

   ColorModC(Widget, const char*, ArgList argv=NULL, Cardinal argc=0);
  ~ColorModC();

//
// Cast to widget
//
   inline operator	Widget() const		{ return form;	}

//
// Return component widgets
//
   inline Widget	Form(void) const	{ return form; }
   inline Widget	Label(void) const	{ return label; }
   inline Widget	DrawingArea(void) const	{ return da; }
   inline Widget	TextField(void) const	{ return tf; }

//
// Return the value and name
//
   inline Pixel		Value()   const	{ return value;   }
   inline StringC	Name()    const	{ return name;    }
   inline Boolean	Changed() const	{ return changed; }

//
// Initialize settings
//
   void		Init(Pixel);
   void		Init(const char*);
   inline void	ResetChanged() { changed = False; }

//
// Change settings back to initial values
//
   void		Reset();
};

#endif // _ColorModC_h_
