/*
 * $Id: ModFormC.h,v 1.1 1998/06/24 01:29:07 lang Exp $
 *
 * Copyright (c) 1992 HAL Computer Systems International, Ltd.
 * 
 *          HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                  1315 Dell Avenue
 *                  Campbell, CA  95008
 *
 * Author: Greg Hilton
 * Contributors: Tom Lang, Frank Bieser, and others
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * http://www.gnu.org/copyleft/gpl.html
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _ModFormC_h_
#define _ModFormC_h_

#include "Base.h"
#include <Xm/Xm.h>

class ModFormC {

protected:

   Widget	modRC;
   Widget	paramFrame;
   Widget	paramTitle;
   Widget	paramForm;
   Widget	colorFrame;
   Widget	colorTitle;
   Widget	colorRC;

   Boolean	autoApply;

   static void	TextChanged    (Widget, Boolean*, XtPointer);
   static void	ChangeAutoApply(Widget, ModFormC*,
				XmToggleButtonCallbackStruct*);

   virtual void	EnableAutoApply();
   virtual void DisableAutoApply();

public:

// Methods

   ModFormC(Widget, const char*, ArgList argv=NULL, Cardinal argc=0);
   virtual ~ModFormC();

//
// Cast to widget
//
   inline operator	Widget() const		{ return modRC;	}

//
// Set values
//
   void			AutoApply(Boolean);

//
// Get values
//
   MEMBER_QUERY(Boolean, AutoApply,  autoApply);
   MEMBER_QUERY(Widget,  ModRC,      modRC);
   MEMBER_QUERY(Widget,  ParamFrame, paramFrame);
   MEMBER_QUERY(Widget,  ParamTitle, paramTitle);
   MEMBER_QUERY(Widget,  ParamForm,  paramForm);
   MEMBER_QUERY(Widget,  ColorFrame, colorFrame);
   MEMBER_QUERY(Widget,  ColorTitle, colorTitle);
   MEMBER_QUERY(Widget,  ColorRC,    colorRC);
};

#endif // _ModFormC_h_
