/*
 *  $Id: TermWinC.h,v 1.1 1998/06/24 01:32:30 lang Exp $
 *  
 *  Copyright (c) 1994 HAL Computer Systems International, Ltd.
 * 
 *          HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                  1315 Dell Avenue
 *                  Campbell, CA  95008
 *
 * Author: Greg Hilton
 * Contributors: Tom Lang, Frank Bieser, and others
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * http://www.gnu.org/copyleft/gpl.html
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
#ifndef _TermWinC_h_
#define _TermWinC_h_

#include <hgl/HalDialogC.h>

class TermC;

class TermWinC : public HalDialogC {

//
// Widgets
//
   TermC	*term;
   Widget	cancelPB;

//
// Data
//
   Boolean	done;
   Boolean	cancelled;

//
// Callbacks
//
   static void	ExitShell(TermC*, TermWinC*);
   static void	DoOk    (Widget, TermWinC*, XtPointer);
   static void	DoCancel(Widget, TermWinC*, XtPointer);

public:

// Methods

   TermWinC(const char*, Widget);
   ~TermWinC();

//
// Execute a command
//
   Boolean	Exec(const char*, Boolean);
   void		Clear();
   void		ShowCancel();
   void		HideCancel();
};

#endif // _TermWinC_h_
